package org.example.lostpet5;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.mime.HttpMultipartMode;
import org.apache.http.entity.mime.MultipartEntity;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.CoreProtocolPNames;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.util.EntityUtils;

import android.app.Activity;
import android.os.AsyncTask;
import android.util.Log;

public class Conexion extends AsyncTask<String, Integer, String>{
	
	Activity actividad;
	List<NameValuePair> pares;	
			
	public Conexion(Activity actividad, List<NameValuePair> pares){
		this.actividad=actividad;
		this.pares=pares;		
	}
	
	@Override
	protected void onPreExecute(){
		super.onPreExecute();		
	}
	
	@Override
	protected String doInBackground(String... params){
		String url=params[0];		
		String opcion=params[1];
		if(opcion.equals("post")){
			try{
				//Poner el timeout
				HttpParams param=new BasicHttpParams();
				HttpConnectionParams.setConnectionTimeout(param,20000);
				 
				//Conectar
				HttpClient client = new DefaultHttpClient(param);
				HttpPost post = new HttpPost(url);
				
				//Las variables post
				try {
					post.setEntity(new UrlEncodedFormEntity(pares));
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				}		
				HttpResponse response = client.execute(post);
			    HttpEntity entity = response.getEntity();
			    InputStream is = entity.getContent();
			    		    
			    //Leer del buffer
			    BufferedReader reader = new BufferedReader(new InputStreamReader(is,"UTF8"),8);
			    StringBuilder sb = new StringBuilder();
			    String line = null;
			    while((line = reader.readLine()) != null) {
			    	sb.append(line);		    	
			    }
			    is.close();
			    return sb.toString();				
			} catch (Exception e) {
				e.printStackTrace();				
				return null;
			}		
		}
		else if(opcion.equals("file")){
			try{
				String fichero=params[2];
				Log.e("Fichero",fichero);
				
				HttpParams param=new BasicHttpParams();
				HttpConnectionParams.setConnectionTimeout(param,20000);
				
				HttpClient httpclient = new DefaultHttpClient();
	            httpclient.getParams().setParameter(CoreProtocolPNames.PROTOCOL_VERSION, HttpVersion.HTTP_1_1);
	            	            
	            HttpPost httppost = new HttpPost(url);
	            File file = new File(fichero);
	            
	            MultipartEntity multipartEntity = new MultipartEntity(HttpMultipartMode.BROWSER_COMPATIBLE);  
	            multipartEntity.addPart("archivo", new FileBody(file));

	            httppost.setEntity(multipartEntity);
	            HttpResponse result = httpclient.execute(httppost);
			    HttpEntity response=result.getEntity();
			    
			    String res=EntityUtils.toString(response);			    
			    return res;
			}
			catch(Exception e){
				e.printStackTrace();				
				return null;
			}		
		}
		return "";	
	}	
	
	@Override
	protected void onPostExecute(String result){
		super.onPostExecute(result);		
	}
	
}
