package org.example.lostpet5;

import java.util.ArrayList;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentStatePagerAdapter;
import android.support.v4.view.PagerAdapter;
import android.support.v4.view.ViewPager;
import android.view.View;

public class Zoom extends FragmentActivity{
	
	ViewPager mPager;
	private PagerAdapter mPagerAdapter;
	private ArrayList<String> imagenes;
	private int posicion;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.zoom);
        imagenes=getIntent().getExtras().getStringArrayList("imagenes");
	    posicion=getIntent().getExtras().getInt("posicion");
	    
        mPager = (ViewPager) findViewById(R.id.contenedor_imagenes);
        mPager.setPageTransformer(true, new ZoomOutPageTransformer());
        mPagerAdapter = new ScreenSlidePagerAdapter(getSupportFragmentManager());
        mPager.setAdapter(mPagerAdapter);
        mPager.setCurrentItem(posicion);
    }
	
    private class ScreenSlidePagerAdapter extends FragmentStatePagerAdapter {
    	
        public ScreenSlidePagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @Override
        public Fragment getItem(int position) {
            SlideImagenes si=new SlideImagenes();
            Bundle args = new Bundle();
            args.putString("ruta", imagenes.get(position));
            si.setArguments(args);
            return si;
        }

        @Override
        public int getCount() {
            return imagenes.size();
        }
    }
    
    private class ZoomOutPageTransformer implements ViewPager.PageTransformer {
        private float MIN_SCALE = 0.85f;
        private float MIN_ALPHA = 0.5f;
        
        @Override
		public void transformPage(View view, float position) {
			int pageWidth = view.getWidth();
            int pageHeight = view.getHeight();

            if (position < -1) { 
                view.setAlpha(0);

            } else if (position <= 1) { // [-1,1]
                float scaleFactor = Math.max(MIN_SCALE, 1 - Math.abs(position));
                float vertMargin = pageHeight * (1 - scaleFactor) / 2;
                float horzMargin = pageWidth * (1 - scaleFactor) / 2;
                if (position < 0) {
                    view.setTranslationX(horzMargin - vertMargin / 2);
                } else {
                    view.setTranslationX(-horzMargin + vertMargin / 2);
                }

                view.setScaleX(scaleFactor);
                view.setScaleY(scaleFactor);

                view.setAlpha(MIN_ALPHA + (scaleFactor - MIN_SCALE) / (1 - MIN_SCALE) * (1 - MIN_ALPHA));

            } else { 
                view.setAlpha(0);
            }
			
		}
    }

}
